#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=Ping.ico
#AutoIt3Wrapper_UseUpx=n
#AutoIt3Wrapper_Res_requestedExecutionLevel=asInvoker
#AutoIt3Wrapper_Res_Icon_Add=ok.ico
#AutoIt3Wrapper_Res_Icon_Add=nok.ico
#AutoIt3Wrapper_Res_File_Add=4wd.jpg, rt_rcdata, 4wd
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <Inet.au3>
#include <Constants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <StaticConstants.au3>
#include <ButtonConstants.au3>
#include <ComboConstants.au3>
#include <EditConstants.au3>
#include "resources.au3"

Global $inifile = StringLeft(@ScriptName, StringLen(@ScriptName) - 4) & '.ini', $proginit, $interval, $CCfail = 0, $ip, $pTT


;--- Tray Menu ---
Opt('TrayMenuMode', 3)
TraySetClick(16)
$configitem = TrayCreateItem('Configuration')
$aboutitem = TrayCreateItem('About')
$exititem = TrayCreateItem('Exit')
TraySetState()
;--- End Tray Menu ---


If FileExists($inifile) Then  ;--- If config file, read settings
	$interval = IniRead($inifile, 'General', 'interval', '30')
	$pTT = IniRead($inifile, 'General', 'ToolTip', True)
	$ip = IniRead($inifile, 'Site', 'IP', 'www.google.com')
Else
	_Config(0)
EndIf
If StringInStr($ip, '/') > 0 Then
	$website = StringLeft($ip, StringInStr($ip, '/') - 1)
Else
	$website = $ip
EndIf
Global $website
TraySetToolTip('AutoPing: ' & $website)
$proginit = TimerInit()

;--- Main loop, wait for Tray input ---
While 1
	$msg = TrayGetMsg()
	Select
		Case $msg = 0
			If TimerDiff($proginit) > ($interval * 1000) Then
				$proginit = TimerInit()
				$test = _INetGetSource('http://' & $ip, 1)
				If @error = 0 Or StringLen($test) > 0 Then
					_ToggleIcon(1)
				Else
					_ToggleIcon(2)
				EndIf
			EndIf
			ContinueLoop
		Case $msg = $configitem
			_Config(1)
		Case $msg = $aboutitem
			_About()
		Case $msg = $exititem
			_Exit()
		Case Else
			ContinueLoop
	EndSelect
WEnd
;--- End Main loop ---

;--- This is the exit function....DOH!
Func _Exit()
	Exit
EndFunc


Func _ToggleIcon($temp)  ;--- Change icon state depending on passed parameter
	Switch $temp
		Case 1
			TraySetIcon(@ScriptName, -5)
			TraySetToolTip($website & @CRLF & 'Status: UP')
			$CCfail = 0
		Case 2
			TraySetIcon(@ScriptName, -6)
			If $CCfail = 0 Then
				If $pTT Then TrayTip('AutoPing', $website & @CRLF & 'Status: DOWN', 5, 2)
				$CCfail = 1
				If Ping('www.google.com') = 0 Then
					$gOK = 'Google: No connection'
				Else
					$gOK = 'Google: Connection OK' & @CRLF
					If _CheckCS($website) = 0 Then
						$cCS = 'CheckSite: Just You'
					Else
						$cCS = 'CheckSite: Everyone'
					EndIf
				EndIf
				TraySetToolTip($website & @CRLF & 'Status: DOWN' & @CRLF & $gOK & $cCS)
			EndIf
		Case Else
	EndSwitch
EndFunc


Func _CheckCS($site)
	Local $temp = InetRead('http://www.checksite.us/?url=' & $site, 1)
	$temp = BinaryToString($temp)
	If StringInStr($temp, 'Yep! We can access') > 0 Then
		Return 0
	Else
		Return 1
	EndIf
EndFunc


Func _Config($_exist=True)
	Local $Config, $Input1, $Input2, $Save, $popup, $nMsg

	If Not $_exist Then
		$ip = 'www.google.com'
		$interval = 30
		$pTT = True
	EndIf
	#Region ### START Koda GUI section ### Form=
	$Config = GUICreate("Config", 335, 139, 192, 124)
	GUICtrlCreateLabel("Web Address:", 8, 16, 84, 17)
	$Input1 = GUICtrlCreateInput($ip, 96, 16, 193, 21)
	GUICtrlSetTip(-1, "Web address to test for connection," & @CRLF & "eg. www.google.com")
	GUICtrlCreateLabel("Interval:", 32, 56, 42, 17)
	$Input2 = GUICtrlCreateInput($interval, 96, 56, 33, 21)
	GUICtrlSetTip(-1, "Interval between each connection attempt" & @CRLF & "in seconds, minimum 15." & @CRLF & "eg. 45 = 45 seconds")
	$popup = GUICtrlCreateCheckbox("Popup warning", 200, 56, 97, 17, -1)
	GUICtrlSetState(-1, $pTT)
	GUICtrlSetTip(-1, "Enable popup tooltip for failed connection.")
	$Save = GUICtrlCreateButton("Save", 48, 96, 75, 25)
	GUICtrlSetTip(-1, "Save settings")
	$Button2 = GUICtrlCreateButton("Cancel", 208, 96, 75, 25)
	GUICtrlSetTip(-1, "Cancel settings")
	GUISetState(@SW_SHOW)
	#EndRegion ### END Koda GUI section ###


	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $Save
				$interval = GUICtrlRead($Input2)
				If $interval < 15 Then $interval = 15
				$pTT = (GUICtrlRead($popup) = $GUI_CHECKED)
				$ip = GUICtrlRead($Input1)
				If $ip = '' Then
					MsgBox(48, 'AutoPing', 'Test address is empty.')
					ContinueLoop
				Else
					If StringUpper(StringLeft($ip, 7)) = 'HTTP://' Then $ip = StringMid($ip, 8)
					IniWrite($inifile, 'General', 'Interval', $interval)
					IniWrite($inifile, 'General', 'ToolTip', $pTT)
					IniWrite($inifile, 'Site', 'IP', $ip)
					ExitLoop
				EndIf
			Case $GUI_EVENT_CLOSE, $Button2
				If Not FileExists($inifile) Then _Exit()
				ExitLoop
		EndSwitch
	WEnd
	GUIDelete($Config)
EndFunc


;--- Open a nice requester with pretty pictures and clicky link things ---
Func _About()
#Region ### START Koda GUI section ### Form=
	$About = GUICreate('About', 170, 181)
	GUICtrlCreateLabel('AutoPing 0.21', 8, 16, 154, 17, $SS_CENTER)
	$DoCo = GUICtrlCreateLabel('http://www.donationcoder.com', 8, 152, 153, 17)
	GUICtrlSetCursor (-1, 0)
	$Pic1 = GUICtrlCreatePic('', 48, 40, 72, 96, BitOR($SS_NOTIFY,$WS_GROUP,$WS_CLIPSIBLINGS))
	_ResourceSetImageToCtrl($Pic1, '4wd')
	GUICtrlSetCursor (-1, 0)
	GUISetState(@SW_SHOW)
#EndRegion ### END Koda GUI section ###

	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $GUI_EVENT_CLOSE
				ExitLoop
			Case $Pic1
				ShellExecute('http://www.donationcoder.com/forum/index.php?action=profile;u=48504')
			Case $DoCo
				ShellExecute('http://www.donationcoder.com')
		EndSwitch
	WEnd
	GUIDelete($About)
EndFunc
